<?php defined('SYSPATH') or die('No direct script access.');

class Controller_DeanOffice_Credits extends Controller_UserEnvironment
{
    public function before() {
        // Ставим кук fD, чтоб иметь возможность скачать файл
        Cookie::set('fD', 'true');
        parent::before();
    }

    public function action_index() {
        $twig = Twig::factory('dean_office/credits');
        $disciplines = Model_Faculty::with($this->user->FacultyID)->getDisciplines();

        $list = array();
        foreach ($disciplines as $dis) {
            if ($dis->type == "credit")
                $list[] = $dis;
        }

        $twig->DisciplinesList = $list;
        $Milestone = Model_Discipline::getMilestone($this->user->FacultyID, $this->user->SemesterID)[0];
        $twig->CurrentMilestone = $Milestone['Num'];
        $twig->User = $this->user;
        $this->response->body($twig);
    }

    public function action_getMilestone() {
        $Milestone = Model_Discipline::getMilestone($this->user->FacultyID, $this->user->SemesterID)[0];
        $this->response->body($Milestone['Num']);
    }

    public function action_getInfo() {
        $id = (int) $_POST['ID'];
        $info = Model_Discipline::getInfo($id);
        $info['Teachers'] = Model_Teachers::getNamesForDiscipline($id, true, true);
        $this->response->body(json_encode($info));
    }

    public function action_setCreditMilestone() {
        $id = (int)$this->request->param("param1");
        $stage = (int)$this->request->param("param2");

        if ($stage >= 0 && $stage <= 3)
            Model_Discipline::setMilestone(0, $id, $stage)[0];
        $this->response->body('');
    }

    public function action_setMilestone() {
        $stage = (int)$this->request->param("param1");
        if ($stage >= 0 && $stage <= 3)
            Model_Discipline::setMilestoneForCredits(0, $this->user->FacultyID, $stage);
        $this->response->body('');
    }
}